Subject: bug#24846: error while loading shared libraries: libgmp.so.10: unexpected PLT reloc type 0x40

From: Yan Markman <[email-masked]>
Date: Tue, 1 Nov 2016 17:10:57 +0000

Thanks Pádraig

I think that described failure is only a symptom  of more generic problem.
 just occasionally failing on coreutils::ls command.
So I would like to understand what exactly this message says.
This message is reported by " ld-2.22.so" but I have no LIB-source-code.

- Have you got an idea what the code 0x40 (PLT reloc type 0x40) means?
- Should the "coretuls" be resident in RAM or could be swapped out under any condition and pumped back upon "ls" command?
- Should the "libgmp.so" be resident in RAM or could be swapped out under any condition?

Thank you very much.
Yan Markman

-----Original Message-----
From: Pádraig Brady [mailto:[email-masked]] 
Sent: Tuesday, November 01, 2016 6:09 PM
To: Yan Markman; [email-masked]
Subject: Re: bug#24846: error while loading shared libraries: libgmp.so.10: unexpected PLT reloc type 0x40

On 11/01/2016 09:09 AM, Pádraig Brady wrote:
> BTW it would be better to configure your coreutils build --without-gmp

Perhaps --enable-single-binary-exceptions=factor,expr should be the default if GMP is used?
On 01/11/16 10:47, Yan Markman wrote:
> Sometimes coreutils commands fails
> and I'm looking a clue what could be root cause or where to debug

> 
> SETUP:
> 
> 1.       System Device is ROUTER
> 
> 2.       Silicone has 2 CPUs of ARM9
> 
> 3.       coreutils (GNU coreutils) 8.24  - 2015
> 
> 4.       File-System NFS over Ethernet/USB
> 
> 5.       High Ethernet traffic with high CPUs' loading (overloading)
> 
> 6.
> PROBLEM:
> Sometimes (hardly reproduced) coreutils commands (for example - "ls", 
> "date") Stop to work and return the below error
> 
> /usr/bin/coreutils: error while loading shared libraries: 
> /usr/lib/libgmp.so.10: unexpected PLT reloc type 0x40

I see you're using the single binary build.

Weird that the problem is intermittent.

Can you memtest your RAM?

Perhaps there are multiple gmp versions on the system and sometimes the wrong one is used?
(that's really stretching)

BTW it would be better to configure your coreutils build --without-gmp That is done for the coreutils-single package in Fedora for example, as the relatively large overhead of GMP for just factor and expr is not a good tradeoff in the single binary use case.

cheers,
Pádraig.